#ifndef _VBFERRY_H_
#define _VBFERRY_H_

#include "../../include/orbitersdk.h"
#include "../../include/guidance.h"
#include "../../include/cvel.h"
#include "../../include/orbitersoundsdk3.h"
//#include "../../include/multi_stage2.h"

//#include "resource.h"
#include <iostream>
#include <cstdio>
#include <cmath>


/*
const DOOR_CLOSED = 0;
const DOOR_OPEN = 2;
const DOOR_CLOSING = 3;
const DOOR_OPENING = 4;
int gear_status;
int pldoors_status;
*/
//enum DoorStatus { DOOR_CLOSED, DOOR_OPEN, DOOR_CLOSING, DOOR_OPENING } pldoors_status;
//typedef UINT GearStatus;
//typedef UINT DoorStatus;
/*
#define PANEL_CLOSED  0x00
#define PANEL_OPEN    0x01
#define PANEL_CLOSING 0x02
#define PANEL_OPENING 0x04
*/

const double GEAR_OPERATING_SPEED = 0.128;
const double PLDOORS_OPERATING_SPEED = 0.128;
const double BRAKES_OPERATING_SPEED = 1.0;
//const double PANEL_OPERATING_SPEED = 0.128;
//const double PANEL_MAX_ANGLE = RAD*90.0;
//static bool have_sound = false;

//#define LOADBMP(id) (LoadBitmap (g_Param.hDLL, MAKEINTRESOURCE (id)))
//GDIParams g_Param;



const VECTOR3 OFS_STAGE1 = { 0, 0, -34.4};
const VECTOR3 OFS_STAGE2 = { 0, 0, 0.0};
const VECTOR3 OFS_STAGE3 = { 0, 0, 20.1};
const VECTOR3 OFS_PAYLOAD = { 0, 1.0, 7.0 };


const double ISP_FIRST_SL  = 230*9.81;
const double ISP_FIRST_VAC = 286*9.81;
const double ISP_SECOND_SL    = 230*9.81;
const double ISP_SECOND_VAC   = 286*9.81;
const double ISP_THIRD_SL    = 230*9.81;
const double ISP_THIRD_VAC   = 286*9.81;

const double STAGE1_EMASS = 770000;
const double STAGE1_PMASS = 5250000;
const double STAGE1_THRUST = 140000000;
const double THRUST_FIRST_VAC = STAGE1_THRUST/8;
const double STAGE2_EMASS = 77000;
const double STAGE2_PMASS = 770000;
const double STAGE2_THRUST = 17500000;
const double THRUST_SECOND_VAC = STAGE2_THRUST/8;
const double STAGE3_EMASS = 24200;
const double STAGE3_PMASS = 87800;
const double STAGE3_THRUST = 2200000;
const double THRUST_THIRD_VAC = STAGE3_THRUST/4;
const double PAYLOADMASS = 21000;
const double H2OMASS = 10000;
const double PEOPLEMASS = 2000;

const double MAX_ATT_FIRST = 4500000;
const double MAX_ATT_SECOND = 120000;
const double MAX_ATT_THIRD = 21000;

#define PLAYGEAR					 20		// the gear sound
#define PLAYBANG					 24		// the jettison sound
#define PLAYBRENNSCHLUSS			 25		// the burnout voice
#define PLAYGROOVE					 26		// the guidance converged voice
#define PLAYDOORS					 27		// the payload doors sound


/*
#define AID_LEDA				0x00
#define AID_LEDB				0x01
#define AID_GUIDANCESTATUS		0x02
#define AID_THRUSTSTATUS		0x03
#define AID_PROPELLANDSTATUS	0x04
#define AID_BDS1				0x05
#define AID_BDS2				0x06
#define AID_BDS3				0x07
#define AID_BDS4				0x08
#define AID_KEYP0				0x09
#define AID_KEYP1				0x0A
#define AID_KEYP2				0x0B
#define AID_KEYP3				0x0C
#define AID_KEYP4				0x0D
#define AID_KEYP5				0x0E
#define AID_KEYP6				0x0F
#define AID_KEYP7				0x10
#define AID_KEYP8				0x11
#define AID_KEYP9				0x12
*/


class VBFERRY: public COMMON_VESSEL_EX,
GUIDANCE {
public:
	VBFERRY (OBJHANDLE hObj, int fmodel);
	~VBFERRY();


	enum DoorStatus { DOOR_CLOSED, DOOR_OPEN, DOOR_CLOSING, DOOR_OPENING } gear_status, pldoors_status, brakes_status;

	void TimeStep( double simt );
	void SetClassCaps( FILEHANDLE cfg );
	void LoadState(FILEHANDLE scn, void *vs );
	void SaveState(FILEHANDLE scn );
	void VisualCreated (VISHANDLE vis, int refcount);
	double H2O;


//	void VLiftCoeff (double aoa, double M, double Re, double *cl, double *cm, double *cd);
//	void HLiftCoeff (double beta, double M, double Re, double *cl, double *cm, double *cd);
	void SetAttControlsFirst();
	void SetAttControlsSecond();
	void SetAttControlsThird();
	void DefineAnimations ();
	void UpdateAnimations();
	void ActivateLandingGear (DoorStatus action);
	void RevertLandingGear ();
	void ActivatePayloadBayDoors (DoorStatus action);
	void RevertPayloadBayDoors ();
	void ActivateBrakes (DoorStatus action);
	void RevertBrakes ();
	void SetGearParameters ( double state);
	void SetFirstStage ();
	void SetSecondStage ();
	void SetThirdStage ();
	void SetThirdStageNoPayload ();
	void SeparateStage ( UINT stage);
	int ConsumeKey( const char *keystate );
	int  ConsumeBufferedKey(DWORD dwKey, bool fPressed, const char *keystate);
//	void UpdatePanels( VESSEL *vessel,VISHANDLE visual, int refcount );

//	void CurrentStage( UINT s ) { stage = s; };
//	UINT CurrentStage() { return stage; };
/*	bool PanelsClosed() {
			if ( panel_status != PANEL_CLOSED )
				return false;
			else
				return true;
		};
*/

//	void ClosePanelsAndSeperate();
//	void InitPanel( int panel );
//	void ReleaseSurfaces ();
//	bool LoadPanel (VESSEL *vessel, int id);
//	bool PanelRedrawEvent(VESSEL *vessel, int id, int event, SURFHANDLE surf);
//	bool PanelMouseEvent( VESSEL *vessel, int id, int event, int mx, int my );

	/**
	*
	*/
//	void RedrawPanel_LED_A (SURFHANDLE surf);
//	void RedrawPanel_LED_B (SURFHANDLE surf);

	/**
	*
	*
	*/

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);


	void Abort();

protected:

	int stage;
	int status;
	double time;
	bool engineignited;
	bool ignition;
	bool People;
	bool BrakesOn;
	bool havesound;

	bool anthem_played;
	double last_simt;
	double ignition_time;
	bool panel_eject;	
	SURFHANDLE tex, texRCS, texy;
	SURFHANDLE srf[1];

	double GetCPitch(double t);
	void Lateral_Guidance(VESSEL *vessel, double SimT, double SimT_Last);
	void Guidance_Routine(VESSEL *vessel, double SimT, double SimT_Last);
	void GetInclinationSP();
	bool IncInput (void *id, char *str, void *data);	
	void InitialiseGuidance();


	bool Guidance() { return guidance; };
	void Guidance( bool g ) { guidance = g; };

	void DisplayInclinationSetPoint( bool d ) { DisplayIncSP=d; };
	bool DisplayInclinationSetPoint() { return DisplayIncSP; };

	void ManualSeparate( bool m ) { bManualSeparate = m; };
	bool ManualSeparate() { return bManualSeparate; };

	int MyID;
	bool GroovePlayed;



	VISHANDLE vis;


	//SURFHANDLE reentry;


	bool have_sound;
	bool ThirdstageExists;
	VESSEL *depV;
	OBJHANDLE hVessel;

	UINT anim_lrudder;     
	UINT anim_rrudder;
	UINT anim_laileron;
	UINT anim_raileron;
	UINT anim_lelevator;
	UINT anim_relevator;
	UINT anim_lelevatortrim;
	UINT anim_relevatortrim;
	UINT anim_gear;     // handle for landing gear animation
	UINT anim_pldoors;     // handle for payload door animation
	UINT anim_brakes;	// handle for speedbrake animation
	double gear_proc;
	double pldoors_proc;
	double brakes_proc;
	int nsurf;
	int stage_sep;
	bool bManualSeparate;
	PROPELLANT_HANDLE ph_first, ph_second, ph_third, ph_H2O;	
	THRUSTER_HANDLE th_first[8];
	THRUSTER_HANDLE th_second[8];
	THRUSTER_HANDLE th_third[4];   
	THGROUP_HANDLE thg_first; 
	THGROUP_HANDLE thg_second; 
	THGROUP_HANDLE thg_third; 
	THGROUP_HANDLE thg_pitchup;
	THGROUP_HANDLE thg_pitchdown;

	int refcount;
	int numevas;
	int Navfreq1, Navfreq2;
	MESHHANDLE hstg1;
	MESHHANDLE hstg2;
	MESHHANDLE hstg3;
	MESHHANDLE vbPayload1;


};



#endif

