#ifndef _VBS2X_H_
#define _VBS2X_H_


#include "../../include/cvel.h"
//#include <common_addon_ex.h>
#include <cstdio>

class VBS2X: public COMMON_VESSEL_EX {
public:
	VBS2X (OBJHANDLE hObj, int fmodel );

	void LoadState (FILEHANDLE scn, void *vs);
	void SaveState (FILEHANDLE scn);
	void SetClassCaps (FILEHANDLE cfg);
	void TimeStep( double simt );
	int  ConsumeBufferedKey ( DWORD dwKey, bool fPressed, const char *keystate);
	int  ConsumeKey ( const char *keystate);
	double EXPAND_SPEED;
	double expand_proc;
	int numevas;

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);

protected :
	PROPELLANT_HANDLE ph_main, ph_H2O;
	THRUSTER_HANDLE th_main[3];
	THRUSTER_HANDLE retro_engine[24];
	THRUSTER_HANDLE th_hover[4];

	THGROUP_HANDLE thg_main;
	THGROUP_HANDLE thg_retro;
	THGROUP_HANDLE thg_hover;
	MESHHANDLE  hHawk;
	SURFHANDLE  tex;
	DOCKHANDLE dock0, dock1, dock2, dock3;
	char payloadmesh[256];
	UINT anim_expand;
};


#endif
