/**
*
* $Id: vbmoon.cpp,v 0.1 2004/11/20 18:03:45 erv Exp $
* (c) 2005 Sputnik -- erik_h_anderson@hotmail.com
* Based on CVEL Centaur-G code
* Ervins Reinverts -- ervins@gmail.com
* Based on CVEL Fregat code
* (c) 2004 David Henderson -- orbiter@aibs.org.uk
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/

#include "vbmoon.h"


VBMOON::VBMOON (OBJHANDLE hObj, int fmodel)
: COMMON_VESSEL_EX (hObj)
{
	hVBMOON				= oapiLoadMeshGlobal ("vbmoonferry");
	hVBMARS				= oapiLoadMeshGlobal ("vbmarsferry");
	hCtrTanks			= oapiLoadMeshGlobal ("vbCtrTanks");
	hCargoCyl			= oapiLoadMeshGlobal ("vbCargocyl");
	hPropTank1			= oapiLoadMeshGlobal ("vbPropTank");
	hPropTank2			= oapiLoadMeshGlobal ("vbPropTank2");
	hSideTank1			= oapiLoadMeshGlobal ("vbSideTank");
	hSideTank2			= oapiLoadMeshGlobal ("vbSideTank2");
	hLeg1				= oapiLoadMeshGlobal ("vbmoonleg1");
	hLeg2				= oapiLoadMeshGlobal ("vbmoonleg2");
	hLeg3				= oapiLoadMeshGlobal ("vbmoonleg3");
	hLeg4				= oapiLoadMeshGlobal ("vbmoonleg4");
	hLeg5				= oapiLoadMeshGlobal ("vbmoonleg5");

	tex = oapiRegisterExhaustTexture("RealExhaust");

	MyID=ConnectToOrbiterSoundDLL3(GetHandle());
	
	RequestLoadVesselWave3(MyID,PLAYGEAR,"Sound\\VB\\gear.wav",BOTHVIEW_FADED_FAR);
	RequestLoadVesselWave3(MyID,PLAYBURN,"Sound\\VB\\BurnNow.wav",BOTHVIEW_FADED_FAR);
	RequestLoadVesselWave3(MyID,PLAYFIVE,"Sound\\VB\\5Seconds.wav",BOTHVIEW_FADED_FAR);
	
	SoundOptionOnOff3(MyID,PLAYATTITUDETHRUST,FALSE);


	/* set the propellant handles to NULL so I can check if I need to 
	/* create them in the SetMainStage() function. */
	ph_TLI=NULL; 
	ph_LAND=NULL;
	ph_TEI=NULL;
	ph_DOCK=NULL;
	ph_RESV=NULL;
	dock0=NULL;
	dock1=NULL;
	tempP = 0.0;
	tempR = 0.0;
	tempY = 0.0;
	gear_status=DOOR_CLOSED;
	gear_proc=0.0;
//	pldoors_status=DOOR_CLOSED;
//	pldoors_proc=0.0;
	JettLegsArm = false;
	stage = 0;

	mars = false;
	cargo = false;
	
	char classname[30];
	int i;
	strncpy( classname, GetClassName(), 29 );
	classname[29]=0;
	for( i = 0 ; i < strlen( classname ) ; i++ ) {
		classname[i] = toupper(classname[i]);
	}
	if( strstr( classname, "VBMOONSHIP" ) ) {
		mars = false;
		cargo = false;
	}
	else if( strstr( classname, "VBMOONCARGO" ) ) {
		mars = false;
		cargo = true;
	}
	else if( strstr( classname, "VBMARSSHIP" ) ) {
		mars = true;
		cargo = false;
	}
	else if( strstr( classname, "VBMARSCARGO" ) ) {
		mars = true;
		cargo = true;
	}

	anim_gear = 0.0;
//	anim_pldoors = 0.0;

	/* CVE-lite function ! */
	/* IMPORTANT */
	/* This function loops through the pending GDPS requests. Have it run
	/* in the constructor so it can set up things like the InitFuelLevel
	/* (initial fuel level) variable, and load the payloads */
	CheckCentralMessage();   

	if (!mars) {

		static UINT GearGrp1[7] = {0,1,2,3,4,5,6};
		static MGROUP_ROTATE Gear1 (4, GearGrp1, 7,
			_V(+6.033,-6.033,-16.1), _V(+.707,+.707,0), (float)(-160*RAD));
		static UINT GearGrp1_1[4] = {7,8,9,10};
		static MGROUP_ROTATE Gear1_1 (4, GearGrp1_1, 4,
			_V(+5.25,-5.25,-16.8), _V(+.707,+.707,0), (float)(-125*RAD));

		static UINT GearGrp2[7] = {0,1,2,3,4,5,6};
		static MGROUP_ROTATE Gear2 (3, GearGrp2, 7,
			_V(+6.033,+6.033,-16.1), _V(-.707,+.707,0), (float)(-160*RAD));
		static UINT GearGrp2_1[4] = {7,8,9,10};
		static MGROUP_ROTATE Gear2_1 (3, GearGrp2_1, 4,
			_V(+5.25,+5.25,-16.8), _V(-.707,+.707,0), (float)(-125*RAD));

		static UINT GearGrp3[7] = {0,1,2,3,4,5,6};
		static MGROUP_ROTATE Gear3 (2, GearGrp3, 7,
			_V(-6.033,+6.033,-16.1), _V(-.707,-.707,0), (float)(-160*RAD));
		static UINT GearGrp3_1[4] = {7,8,9,10};
		static MGROUP_ROTATE Gear3_1 (2, GearGrp3_1, 4,
			_V(-5.25,+5.25,-16.8), _V(-.707,-.707,0), (float)(-125*RAD));

		static UINT GearGrp4[7] = {0,1,2,3,4,5,6};
		static MGROUP_ROTATE Gear4 (1, GearGrp4, 7,
			_V(-6.033,-6.033,-16.1), _V(+.707,-.707,0), (float)(-160*RAD));
		static UINT GearGrp4_1[4] = {7,8,9,10};
		static MGROUP_ROTATE Gear4_1 (1, GearGrp4_1, 4,
			_V(-5.25,-5.25,-16.8), _V(+.707,-.707,0), (float)(-125*RAD));

		static UINT GearGrp5_1[3] = {0,1,2};
		static MGROUP_TRANSLATE Gear5_1 (5, GearGrp5_1, 3,
			_V( 0,0,3.2));
		static UINT GearGrp5_2[2] = {1,2};
		static MGROUP_TRANSLATE Gear5_2 (5, GearGrp5_2, 2,
			_V( 0,0,6.8));
		static UINT GearGrp5_3[1] = {2};
		static MGROUP_TRANSLATE Gear5_3 (5, GearGrp5_3, 1,
			_V( 0,0,5.5));

		anim_gear = CreateAnimation (0);

		hG1 = AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear1);
		hG11= AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear1_1);
		hG2 = AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear2);
		hG21= AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear2_1);
		hG3 = AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear3);
		hG31= AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear3_1);
		hG4 = AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear4);
		hG41= AddAnimationComponent (anim_gear, 0.4, 0.9, &Gear4_1);

		hG51= AddAnimationComponent (anim_gear, 0.25, 0.35, &Gear5_1);
		hG52= AddAnimationComponent (anim_gear, 0.15, 0.25, &Gear5_2);
		hG53= AddAnimationComponent (anim_gear, 0.05, 0.15, &Gear5_3);

	}

	Sweepnum = 0;

}


VBMOON::~VBMOON()
{

}

void VBMOON::UpdateAnimations()
{	
	if (mars) return;
	if ((stage < 2) || (JettLegsArm)) {
		// animate landing gear
		if (gear_status >= DOOR_CLOSING) {
			double da = oapiGetSimStep() * GEAR_OPERATING_SPEED;
			if (gear_status == DOOR_CLOSING) {
				if (gear_proc > 0.0)
					gear_proc = max (0.0, gear_proc-da);
				else {
					gear_status = DOOR_CLOSED;
				}
			} else  { // door opening
				if (gear_proc < 1.0)
					gear_proc = min (1.0, gear_proc+da);
				else {
					gear_status = DOOR_OPEN;
				}
			}
			SetAnimation (anim_gear, gear_proc);
		}
	}
/*
	// animate payload bay doors
	if (pldoors_status >= DOOR_CLOSING) {
		double da = oapiGetSimStep() * PLDOORS_OPERATING_SPEED;
		if (pldoors_status == DOOR_CLOSING) {
			if (pldoors_proc > 0.0)
				pldoors_proc = max (0.0, pldoors_proc-da);
			else {
				pldoors_status = DOOR_CLOSED;
			}
		} else  { // door opening
			if (pldoors_proc < 1.0)
				pldoors_proc = min (1.0, pldoors_proc+da);
			else {
				pldoors_status = DOOR_OPEN;
			}
		}
		SetAnimation (anim_pldoors, pldoors_proc);
	}
*/

}

void VBMOON::ActivateLandingGear (DoorStatus action)
{
	gear_status = action;
}

void VBMOON::RevertLandingGear ()
{
	if (!mars)
	ActivateLandingGear (gear_status == DOOR_CLOSED || gear_status == DOOR_CLOSING ?
						 DOOR_OPENING : DOOR_CLOSING);
//	StopVesselWave3(MyID,PLAYGEAR);
//	PlayVesselWave3(MyID,PLAYGEAR);
}
/*
void VBMOON::ActivatePayloadBayDoors (DoorStatus action)
{
	pldoors_status = action;
}

void VBMOON::RevertPayloadBayDoors ()
{
	ActivatePayloadBayDoors (pldoors_status == DOOR_CLOSED || pldoors_status == DOOR_CLOSING ?
						 DOOR_OPENING : DOOR_CLOSING);
}
*/
void VBMOON::SetGearParameters (double state)
{

	double alt = GetAltitude();
	if ((alt > 30.0) && (alt < 38.0) && (gear_status == DOOR_CLOSED)) {
		gear_proc = 0.05-((alt-38.0)/60);
		SetAnimation (anim_gear, gear_proc);
	}
/*	double geary = (-1*(gear_proc-1.0)*0.6);
	SetTouchdownPoints (_V(0,-1.8+geary,14.0), _V(-9.15,-2.0+geary,-3.0), _V(9.15,-2.0+geary,-3.0));
	if (state == 1.0) {
		SetSurfaceFrictionCoeff (0.1, 0.4);
	} else {
		SetSurfaceFrictionCoeff (0.1, 0.4);		// Wire brushes; no brakes!
	}
*/
}


void VBMOON::JettisonLegs ()
{
	if (mars) return;
	char name[256];
	VESSELSTATUS vs;
	VECTOR3 ofs = _V(0,0,0);
	VECTOR3 vel = _V(0,0,-2.0);
	GetStatus (vs);
	VECTOR3 rofs, rvel = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
	Local2Rel (ofs, vs.rpos);
	GlobalRot (vel, rofs);
	vs.rvel.x = rvel.x+rofs.x;
	vs.rvel.y = rvel.y+rofs.y;
	vs.rvel.z = rvel.z+rofs.z;

		vs.vrot.x = 0.1;
		vs.vrot.y = 0.0;
		vs.vrot.z = 0.0;
		strcpy (name, GetName()); strcat (name, "-Leg 1");
		VESSEL::Create (name, "vbmoonleg1", vs);
		
		vs.vrot.x = -0.05;
		vs.vrot.y = 0.0;
		vs.vrot.z = 0.0;
		strcpy (name, GetName()); strcat (name, "-Leg 2");
		VESSEL::Create (name, "vbmoonleg2", vs);
		
		vs.vrot.x = -0.08;
		vs.vrot.y = 0.03;
		vs.vrot.z = 0.0;
		strcpy (name, GetName()); strcat (name, "-Leg 3");
		VESSEL::Create (name, "vbmoonleg3", vs);
		
		vs.vrot.x = 0.03;
		vs.vrot.y = -0.02;
		vs.vrot.z = 0.0;
		strcpy (name, GetName()); strcat (name, "-Leg 4");
		VESSEL::Create (name, "vbmoonleg4", vs);

		vs.vrot.x = 0.01;
		vs.vrot.y = -0.01;
		vs.vrot.z = 0.0;
		strcpy (name, GetName()); strcat (name, "-Leg 5");
		VESSEL::Create (name, "vbmoonleg5", vs);

	DelAnimationComponent(anim_gear,hG1);
	DelAnimationComponent(anim_gear,hG11);
	DelAnimationComponent(anim_gear,hG2);
	DelAnimationComponent(anim_gear,hG21);
	DelAnimationComponent(anim_gear,hG3);
	DelAnimationComponent(anim_gear,hG31);
	DelAnimationComponent(anim_gear,hG4);
	DelAnimationComponent(anim_gear,hG41);

	DelAnimationComponent(anim_gear,hG51);
	DelAnimationComponent(anim_gear,hG52);
	DelAnimationComponent(anim_gear,hG53);

}
/*
void VBMOON::SeparateEVA ()
{
	VESSELSTATUS vs;
	GetStatus (vs);
	vs.eng_main = vs.eng_hovr = 0.0;
	vs.fuel=1.0;
	VECTOR3 ofs = ASTRO_OFS;
	if (vs.status == 1) ofs = ASTROLANDED_OFS;
//	vs.status=0;
	Local2Rel (ofs, vs.rpos);
	char name[256];
	strcpy (name, GetName()); strcat (name, "-PLT");
	VESSEL::Create (name, "vbsuit", vs);

}
*/
void VBMOON::TimeStep(  double simt )
{
	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* This function loops through the pending GPDS requests and returns a bool (true/false)
	/* if any GPDS requests have been implemented.
	/* If any have (eg adding a new payload), you will need to re-draw your ship, hence the
	/* call to the (repeatable) SetMainStage(); */
	if( CheckCentralMessage() ) {
		while( CheckCentralMessage() ) ;
			SetMainStage();
	}

	VESSELSTATUS2 vs;
	GetStatusEx (&vs);

	if (stage == 1)
		if (vs.status == 0)
			if (oapiGetFocusObject() == GetHandle()) {

		dV = ISP_FIRST_VAC*log((GetMass())/(THIRD_PROP_MASS+VBMOON_DRYMASS+SMALLTANKS_DRYMASS+CalculateMass()));
		mdot = 30*THRUST_FIRST_VAC/ISP_FIRST_VAC;
		BurnTime = ((GetMass())-(THIRD_PROP_MASS+VBMOON_DRYMASS+SMALLTANKS_DRYMASS+CalculateMass()))/mdot;
		oapiGetAirspeedVector(GetHandle(),&Rel_Vel);
		oapiGetPitch(GetHandle(),&pitchangle);
		pitchangle = PI/2 - pitchangle;
		pitchangle *= 0.5;
		pitchangle = PI/2 - pitchangle;
		FallTime = (-1.0*GetAltitude()/Rel_Vel.y) + 0.5*(sin(pitchangle))*((sqrt(1.667*GetAltitude()))/2);
//		sprintf(oapiDebugString(), "Burntime, FallTime, dv, mdot, vel: %.3f %.3f %.3f %.3f %.3f", BurnTime, 
//			FallTime, dV, mdot, Rel_Vel.y); 


		if (Rel_Vel.y < -250) {
			if (((FallTime - BurnTime) < 5.0) && ((FallTime - BurnTime) > 0.0) && (GetThrusterGroupLevel(THGROUP_MAIN) < 0.1)) {
				sprintf(oapiDebugString(), "Initiate Burn In: %.1f", (FallTime - BurnTime)); 
				if ((!IsPlaying3(MyID,PLAYFIVE)) && ((FallTime - BurnTime) > 3.9))
					PlayVesselWave3(MyID,PLAYFIVE);
				if (oapiGetTimeAcceleration() > 1) oapiSetTimeAcceleration(1.0) ;
			}
			else if (((FallTime - BurnTime) < 0.0) && ((FallTime - BurnTime) > -1.5) && (GetThrusterGroupLevel(THGROUP_MAIN) < 0.1)) {
				sprintf(oapiDebugString(), "Initiate Burn NOW"); 
				if (!IsPlaying3(MyID,PLAYBURN))
					PlayVesselWave3(MyID,PLAYBURN);
				if (oapiGetTimeAcceleration() > 1) oapiSetTimeAcceleration(1.0) ;
			}
			else if (GetThrusterGroupLevel(THGROUP_MAIN) > 0.5) sprintf(oapiDebugString(), "");

		}

	}

	
	UpdateAnimations();
	if (!mars)
		if ((JettLegsArm) || (stage < 2))
			SetGearParameters(gear_proc);
	VectorThrust();
	if ((JettLegsArm) && (vs.status == 0))
		if (GetAltitude() > 38.0){
			JettisonLegs();
			JettLegsArm = false;
			SetMainStage();
//			ClearMeshesEx();
//			PlaceComponents();
//			Draw();
		}
	if (Sweepnum < 10) Sweepnum++;
}

/* CVE-lite function ! */
/* IMPORTANT */
/* VisualCreated() is a function passed through from CVE-lite as a direct replacement
/* for the DLLCLBK ovcVisualCreated() function.
/* You can't use ovcVisualCreated() with CVE-lite, so use this instead! */

void VBMOON::VisualCreated ( VESSEL *vessel, VISHANDLE vis, int refcount) {
	/* local equivalent to the DLLCLBK ovcVisualCreated() */
	SetMainStage(); // this is a good place to ask for the initial setup.
}


void VBMOON::SetClassCaps(  FILEHANDLE cfg )
{

	CheckCentralMessage();

	SetMainStage();
}

void VBMOON::SaveState( FILEHANDLE scn )
{
	char cbuf[256];

	SaveDefaultState (scn);
	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* Call this after the normal SaveDefautState() to record attached payloads
	/* it the scenario file */


//	Undock(ALLDOCKS);

	oapiWriteScenario_int (scn, "CONFIGURATION", stage);
	sprintf (cbuf, "%d %0.4f", gear_status, gear_proc);
	if (!mars)
		oapiWriteScenario_string (scn, "GEAR", cbuf);
	oapiWriteScenario_int (scn, "LEG JETT ARMED", JettLegsArm);

	/* save payload lines */
	SaveDefaultStateEx(scn);
}

void VBMOON::LoadState(  FILEHANDLE scn, void *vs )
{
    char *line;

	while (oapiReadScenario_nextline (scn, line)) 
	{
		/* CVE-lite function ! */
		/* IMPORTANT */
		/* Call this for every line in the scenario file. It will automatically
		/* deduce which lines are for it, and load the payloads from the file. */

		/* load payload lines */
		if (!strnicmp (line, "CONFIGURATION", 13)) {
		    sscanf (line+13, "%d", &stage);
		} else if (!strnicmp (line, "GEAR", 4)) {
		sscanf (line+4, "%d%lf", &gear_status, &gear_proc);
		} else if (!strnicmp (line, "LEG JETT ARMED", 14)) {
			sscanf (line+14, "%d", &JettLegsArm);
		} else ParsePayloadString(line);

		ParseScenarioLineEx (line, vs);
	}

	if ((stage < 2) || (JettLegsArm)) {
		RevertLandingGear();
		RevertLandingGear();
	}
	else {
		DelAnimationComponent(anim_gear,hG1);
		DelAnimationComponent(anim_gear,hG11);
		DelAnimationComponent(anim_gear,hG2);
		DelAnimationComponent(anim_gear,hG21);
		DelAnimationComponent(anim_gear,hG3);
		DelAnimationComponent(anim_gear,hG31);
		DelAnimationComponent(anim_gear,hG4);
		DelAnimationComponent(anim_gear,hG41);

		DelAnimationComponent(anim_gear,hG51);
		DelAnimationComponent(anim_gear,hG52);
		DelAnimationComponent(anim_gear,hG53);
	}


	/* always set the stage whenever something may have changed */
	SetMainStage();

//	RevertPayloadBayDoors();
//	RevertPayloadBayDoors();

}

void VBMOON::VectorThrust()
{
// Vector the thrust 

		if (oapiGetTimeAcceleration() > 10) return;

		if (GetFocus() == GetHandle()) {
			tempP = GetManualControlLevel(THGROUP_ATT_PITCHDOWN, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - 
				GetManualControlLevel(THGROUP_ATT_PITCHUP, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);

			tempY = GetManualControlLevel(THGROUP_ATT_YAWLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - 
				GetManualControlLevel(THGROUP_ATT_YAWRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);

			tempR = GetManualControlLevel(THGROUP_ATT_BANKLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - 
				GetManualControlLevel(THGROUP_ATT_BANKRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);

		} else {
			tempP = 0.0;
			tempY = 0.0;
			tempR = 0.0;
		}
		if (Sweepnum < 3) return;
	 
		if( GetNavmodeState(NAVMODE_KILLROT) ) {
			GetAngularVel(AngularVel);
			tempP+=( 50*AngularVel.x);			// Bias the thrust vector AGAINST the angular velocity a bit
			tempY+=(-50*AngularVel.y);			// This will damp angular velocity, preventing loss of control
			tempR+=(10*AngularVel.z);
		}

		if (tempP >  1.0) tempP = 1.0;
		if (tempP < -1.0) tempP = -1.0;
		if (tempY >  1.0) tempY = 1.0;
		if (tempY < -1.0) tempY = -1.0;
		if (tempR >  1.0) tempR = 1.0;
		if (tempR < -1.0) tempR = -1.0;

		if (!mars) {
			SetThrusterDir(th_first[ 0],_V(0.2*(tempY-tempR),0,0.9));
			SetThrusterDir(th_first[ 1],_V(0.2*(tempY-tempR),0,0.9));
			SetThrusterDir(th_first[ 2],_V(0.2*(tempY-tempR),0,0.9));
			SetThrusterDir(th_first[ 3],_V(0.2*(tempY+tempR),0,0.9));
			SetThrusterDir(th_first[ 4],_V(0.2*(tempY+tempR),0,0.9));
			SetThrusterDir(th_first[ 5],_V(0.2*(tempY+tempR),0,0.9));
			SetThrusterDir(th_first[ 6],_V(0,0.2*(tempP+tempR),0.9));
			SetThrusterDir(th_first[ 7],_V(0,0.2*(tempP+tempR),0.9));
			SetThrusterDir(th_first[ 8],_V(0,0.2*(tempP+tempR),0.9));
			SetThrusterDir(th_first[ 9],_V(0,0.2*(tempP-tempR),0.9));
			SetThrusterDir(th_first[10],_V(0,0.2*(tempP-tempR),0.9));
			SetThrusterDir(th_first[11],_V(0,0.2*(tempP-tempR),0.9));
		}
		else {
			SetThrusterDir(th_first[ 0],_V(0.2*(tempY-tempR),0,0.9));
			SetThrusterDir(th_first[ 1],_V(0.2*(tempY-tempR),0,0.9));
			SetThrusterDir(th_first[ 2],_V(0.2*(tempY+tempR),0,0.9));
			SetThrusterDir(th_first[ 3],_V(0.2*(tempY+tempR),0,0.9));
			SetThrusterDir(th_first[ 4],_V(0,0.2*(tempP+tempR),0.9));
			SetThrusterDir(th_first[ 5],_V(0,0.2*(tempP+tempR),0.9));
			SetThrusterDir(th_first[ 6],_V(0,0.2*(tempP-tempR),0.9));
			SetThrusterDir(th_first[ 7],_V(0,0.2*(tempP-tempR),0.9));
		}

}

void VBMOON::PlaceComponents()
{
	COMMON_MESH tmp;

	if (mars) {
		tmp.MeshHandle(hVBMARS);
		tmp.MeshPosition(_V(0,0,0));
		AddMeshEx (tmp);
	}
	else {
		tmp.MeshHandle(hVBMOON);
		tmp.MeshPosition(_V(0,0,0));
		AddMeshEx (tmp);
		if ((stage < 2) || (JettLegsArm)) {
			tmp.MeshHandle(hLeg1);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
			tmp.MeshHandle(hLeg2);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
			tmp.MeshHandle(hLeg3);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
			tmp.MeshHandle(hLeg4);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
			tmp.MeshHandle(hLeg5);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
		}
	}

	if (stage < 3) {
		if (cargo) {
			tmp.MeshHandle(hCargoCyl);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
		}
		else {
			tmp.MeshHandle(hCtrTanks);
			tmp.MeshPosition(_V(0,0,0));
			AddMeshEx (tmp);
		}
	}

	if (stage < 1) {
		tmp.MeshHandle(hPropTank1);
		tmp.MeshPosition(_V(0,0,0));
		AddMeshEx (tmp);
		tmp.MeshHandle(hPropTank2);
		tmp.MeshPosition(_V(0,0,0));
		AddMeshEx (tmp);
	}

	if (stage < 2) {
		tmp.MeshHandle(hSideTank1);
		tmp.MeshPosition(_V(0,3.5,0));
		AddMeshEx (tmp);
		tmp.MeshHandle(hSideTank2);
		tmp.MeshPosition(_V(0,-3.5,0));
		AddMeshEx (tmp);
	}

}

/* IMPORTANT */
/* Always have a function that you can call as many times as you like that will re-draw
/* all you meshes, reset all your thrusters and check to make sure the propellent is
/* there. This should be called after any configuration change, or any GDPS line (see
/* TimeStep(), above) */

void VBMOON::SetMainStage( )
{

	Sweepnum = 0;
	if (stage == 1)
		SetStage1();
	else if (stage > 1)
		SetStage2();
	else 
		SetStage0();
}

void VBMOON::MakeThrusters(PROPELLANT_HANDLE ph_X)
{

	int i;

	PARTICLESTREAMSPEC contrail = 
	{
		0, 25.0, 7, 350, 0.3, 4.0, 7, 3.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};

	PARTICLESTREAMSPEC exhaust_main = {
		0, 3, 25, 350, 0.1, 0.2, 28, 1.0, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};
	exhaust_main.tex = oapiRegisterParticleTexture ("Contrail2");

	if (!mars) {
	th_first[12] = CreateThruster ( _V(-2.97, 3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[13] = CreateThruster ( _V(-0.97, 3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[14] = CreateThruster ( _V( 2.97, 3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[15] = CreateThruster ( _V( 0.97, 3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[16] = CreateThruster ( _V(-3.97, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[17] = CreateThruster ( _V(-1.97, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[18] = CreateThruster ( _V( 3.97, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[19] = CreateThruster ( _V( 1.97, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[20] = CreateThruster ( _V(-2.97, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[21] = CreateThruster ( _V( 2.97, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[22] = CreateThruster ( _V(-2.97,-3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[23] = CreateThruster ( _V(-0.97,-3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[24] = CreateThruster ( _V( 2.97,-3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[25] = CreateThruster ( _V( 0.97,-3.50,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[26] = CreateThruster ( _V(-3.97,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[27] = CreateThruster ( _V(-1.97,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[28] = CreateThruster ( _V( 3.97,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[29] = CreateThruster ( _V( 1.97,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);

	th_first[ 0] = CreateThruster ( _V(-3.30, 6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 1] = CreateThruster ( _V( 0.00, 6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 2] = CreateThruster ( _V( 3.30, 6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 3] = CreateThruster ( _V(-3.30,-6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 4] = CreateThruster ( _V( 0.00,-6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 5] = CreateThruster ( _V( 3.30,-6.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 6] = CreateThruster ( _V( 6.00,-3.30,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 7] = CreateThruster ( _V( 6.00, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 8] = CreateThruster ( _V( 6.00, 3.30,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 9] = CreateThruster ( _V(-6.00,-3.30,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[10] = CreateThruster ( _V(-6.00, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[11] = CreateThruster ( _V(-6.00, 3.30,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);

	thg_first = CreateThrusterGroup (th_first, 30, THGROUP_MAIN);

//	if (stage > 2)
//			for( i = 0 ; i < 12 ; i++ )
//		AddExhaust (th_first[i], 12.0, 1.5, tex);
//	else
		for( i = 0 ; i < 30 ; i++ )
			AddExhaust (th_first[i], 12.0, 1.5, tex);
	}
	else
	{
	th_first[ 8] = CreateThruster ( _V(-2.00, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 9] = CreateThruster ( _V( 0.00, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[10] = CreateThruster ( _V( 2.00, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[11] = CreateThruster ( _V( 1.00, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[12] = CreateThruster ( _V(-1.00, 0.00,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[13] = CreateThruster ( _V(-2.00,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[14] = CreateThruster ( _V( 0.00,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[15] = CreateThruster ( _V( 2.00,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);

	th_first[ 0] = CreateThruster ( _V( 1.75, 3.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 1] = CreateThruster ( _V(-1.75, 3.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 2] = CreateThruster ( _V( 1.75,-3.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 3] = CreateThruster ( _V(-1.75,-3.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 4] = CreateThruster ( _V( 3.75, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 5] = CreateThruster ( _V( 3.75,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 6] = CreateThruster ( _V(-3.75, 1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_first[ 7] = CreateThruster ( _V(-3.75,-1.75,-21.0), _V(0,0,1), THRUST_FIRST_VAC, ph_X, ISP_FIRST_VAC, ISP_FIRST_SL);

	thg_first = CreateThrusterGroup (th_first, 16, THGROUP_MAIN);

//	if (stage > 2)
//			for( i = 0 ; i < 8 ; i++ )
//		AddExhaust (th_first[i], 12.0, 1.5, tex);
//	else
		for( i = 0 ; i < 16 ; i++ )
			AddExhaust (th_first[i], 12.0, 1.5, tex);

	}
	EnableTransponder(true);

	THRUSTER_HANDLE th_rot[2];
	texRCS  = oapiRegisterExhaustTexture ("exhaust_atrcs");

	th_rot[0] = CreateThruster (_V(0,0, 25), _V(0, 1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(0,0,-25), _V(0,-1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7, 0.25,-5.5), _V(0,1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7, 0.25,-5.5), _V(0,1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.18,-1.27,-0.35), _V(0,-1.0,0.0),texRCS);  // X-20
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.18,-1.27,-0.35), _V(0,-1.0,0.0),texRCS);  // X-20
	thg_pitchup=CreateThrusterGroup (th_rot, 2, THGROUP_ATT_PITCHUP);

	th_rot[0] = CreateThruster (_V(0,-0.2,-5.25), _V(0,1,0),MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,-0.75,5.25), _V(0,1,0),MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.18,-1.27,-0.35), _V(0,-1.0,0.0),texRCS);  // X-20
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.18,-1.27,-0.35), _V(0,-1.0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_UP);

	th_rot[0] = CreateThruster (_V(0,-0.2,-5.25), _V(0,-1,0), MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,-0.75,5.25), _V(0,-1,0), MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7, 0.25,-5.5), _V(0,1.0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7, 0.25,-5.5), _V(0,1.0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 0.8, 0.25, _V( 2.15,-1.0, 3.94), _V(0, 1.0,0.0),texRCS);  // X-20
	AddExhaust (th_rot[0], 0.8, 0.25, _V(-2.15,-1.0, 3.94), _V(0, 1.0,0.0),texRCS);  // X-20
	AddExhaust (th_rot[0], 0.8, 0.25, _V( 2.30,-1.0, 3.80), _V(0, 1.0,0.0),texRCS);  // X-20
	AddExhaust (th_rot[0], 0.8, 0.25, _V(-2.30,-1.0, 3.80), _V(0, 1.0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_DOWN);

	th_rot[0] = CreateThruster (_V(0,0, 25), _V(0,-1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(0,0,-25), _V(0, 1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 0.8, 0.25, _V( 2.15,-1.0, 3.94), _V(0, 1.0,0.0),texRCS);  // X-20
//	AddExhaust (th_rot[0], 0.8, 0.25, _V(-2.15,-1.0, 3.94), _V(0, 1.0,0.0),texRCS);  // X-20
//	AddExhaust (th_rot[0], 0.8, 0.25, _V( 2.30,-1.0, 3.80), _V(0, 1.0,0.0),texRCS);  // X-20
//	AddExhaust (th_rot[0], 0.8, 0.25, _V(-2.30,-1.0, 3.80), _V(0, 1.0,0.0),texRCS);  // X-20
	thg_pitchdown=CreateThrusterGroup (th_rot, 2, THGROUP_ATT_PITCHDOWN);

	th_rot[0] = CreateThruster (_V(0,0, 25), _V(-1,0,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(0,0,-25), _V( 1,0,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21, 1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21,-1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.10,-0.50, 2.3), _V( 1.0,0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_YAWLEFT);

	th_rot[0] = CreateThruster (_V(0,0, 25), _V( 1,0,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(0,0,-25), _V(-1,0,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25, 1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25,-1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.10,-0.50, 2.3), _V(-1.0,0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_YAWRIGHT);

	th_rot[0] = CreateThruster (_V(2,0.0,0.0), _V(-1,0,0), MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25, 1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25,-1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.10,-0.50, 2.3), _V( 1.0,0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_LEFT);

	th_rot[0] = CreateThruster (_V(2,0.0,0.0), _V(1,0,0),MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21, 1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21,-1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.10,-0.50, 2.3), _V(-1.0,0,0.0),texRCS);  // X-20
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_RIGHT);

	th_rot[0] = CreateThruster (_V( 25,0,0), _V(0,-1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(-25,0,0), _V(0, 1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21, 1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25,-1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7, 0.25,-5.5 ), _V(0,1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_BANKRIGHT);

	th_rot[0] = CreateThruster (_V( 25,0, 0), _V(0, 1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
	th_rot[1] = CreateThruster (_V(-25,0,0), _V(0, -1,0), MAX_ATT_FIRST, ph_X, ISP_GYRO);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.25, 1.7,-5.55), _V( 1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-0.21,-1.7,-5.35), _V(-1.0,0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7,-0.187,-5.35), _V(0,-1.0,0.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7, 0.25,-5.5 ), _V(0,1.0,0.0),texRCS);  // Transtage
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_BANKLEFT);

	th_rot[0] = CreateThruster (_V(0,0, -4), _V(0,0,1), MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7, 0.0,-5.75), _V(0,0,-1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7, 0.0,-5.75), _V(0,0,-1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.0, 1.7,-5.75), _V(0,0,-1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.0,-1.7,-5.75), _V(0,0,-1.0),texRCS);  // Transtage
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_FORWARD);
	th_rot[0] = CreateThruster (_V(0,0, 4), _V(0,0,-1), MAX_ATT_FIRST, ph_X, ISP_FIRST_SL);
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 1.7, 0.0,-5.15), _V(0,0,1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V(-1.7, 0.0,-5.15), _V(0,0,1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.0, 1.7,-5.15), _V(0,0,1.0),texRCS);  // Transtage
//	AddExhaust (th_rot[0], 1.5, 0.35, _V( 0.0,-1.7,-5.15), _V(0,0,1.0),texRCS);  // Transtage
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_BACK);

}

void VBMOON::SetStage0( )
{


	/* CVE-lite function ! */
	/* ClearMeshesEx() will get rid of all the normal meshes, plus anything you've defined
	/* with the COMMON_MESH class (not used here) */

	/* erase all meshes and thrusters so we can start afresh */
	ClearMeshesEx();
	ClearThrusterDefinitions();
//	ClearPropellantResources();

	SetSize (35);

	/* CVE-lite function ! */
	/* IMPORTANT */
	/* double CalculateMass() will return the all-up mass of the combined payloads and
	/* upper stages. Simply add this to your normal dry mass. */
	
	/* always add payload mass [CalculateMass()] to the vessel's empty mass */
	SetEmptyMass ( VBMOON_DRYMASS + BIGTANKS_DRYMASS + SMALLTANKS_DRYMASS + SECOND_PROP_MASS + THIRD_PROP_MASS + CalculateMass() );

	SetTouchdownPoints (_V(0,-12.0,-31.5), _V(-9,9,-31.5), _V(9,9,-31.5));
//	dock0 = CreateDock (_V( 0.0, 0.0 , 17.3), _V( 0, 0, 1), _V(0,1, 0));
	if (dock0 == NULL) dock0 = CreateDock (_V( 2.05,-2.05 , 7.15), _V( 0.707,-0.707, 0), _V(0,0, 1));
	if (dock1 == NULL) dock1 = CreateDock (_V(-0.75, 0.75 , 7.15), _V(-0.707, 0.707, 0), _V(0.707,0.707, 0));
	SetPMI (_V(220,280,260));  //_V(210,246,175) w/o tanks
	SetCrossSections (_V(330,480,170));  //_V(286,304,77) w/o tanks
	SetCW (0.8, 1.0, 1.4, 1.4);
	SetRotDrag (_V(0.7,0.7,1.2));
	SetPitchMomentScale (1e-6);
	SetBankMomentScale (1e-6);
//	SetLiftCoeffFunc (0); 
//	SetTrimScale (0.05);
	SetCameraOffset(_V(3.44,0.4,14.8));
//	SetMeshVisibilityMode(3,MESHVIS_ALWAYS);

	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* Draw() should be called to render all the loaded payloads, plus anything you've
	/* added with the COMMON_MESH class (not used here) */

	/* call draw to render the payloads, plus anything you've added from COMMON_MESH */
	PlaceComponents();
	Draw();


	/* CVE-lite variable ! */
	/* IMPORTANT */
	/* Use the keyword double InitFuelLevel multipled by the maximum mass to have the
	/* fuel levels automatically set from the GPDS payload string */

	/* verify that the propellent hasn't been created before making it */
	if (ph_TLI==NULL)  
		ph_TLI  = CreatePropellantResource(FIRST_PROP_MASS,FIRST_PROP_MASS*InitFuelLevel,1.0); 
	if (ph_LAND!=NULL)
		DelPropellantResource(ph_LAND);
	if (ph_TEI!=NULL)
		DelPropellantResource(ph_TEI);
/*	if (ph_LAND==NULL)  
		ph_LAND  = CreatePropellantResource(SECOND_PROP_MASS); 
	if (ph_TEI==NULL)  
		ph_TEI  = CreatePropellantResource(THIRD_PROP_MASS); 
	if (ph_DOCK==NULL)  
		ph_DOCK  = CreatePropellantResource(FOURTH_PROP_MASS); 
*/

	SetDefaultPropellantResource (ph_TLI); 
	MakeThrusters (ph_TLI);
}

void VBMOON::SetStage1( )
{
	
	/* CVE-lite function ! */
	/* ClearMeshesEx() will get rid of all the normal meshes, plus anything you've defined
	/* with the COMMON_MESH class (not used here) */

	/* erase all meshes and thrusters so we can start afresh */
	ClearMeshesEx();
	ClearThrusterDefinitions();
//	ClearPropellantResources();

	SetSize (35);

	/* CVE-lite function ! */
	/* IMPORTANT */
	/* double CalculateMass() will return the all-up mass of the combined payloads and
	/* upper stages. Simply add this to your normal dry mass. */
	
	/* always add payload mass [CalculateMass()] to the vessel's empty mass */
	SetEmptyMass ( VBMOON_DRYMASS + SMALLTANKS_DRYMASS + THIRD_PROP_MASS + CalculateMass() );

	SetTouchdownPoints (_V(0,-12.0,-31.5), _V(-9,9,-31.5), _V(9,9,-31.5));
	if (dock0 == NULL) dock0 = CreateDock (_V( 2.05,-2.05 , 7.15), _V( 0.707,-0.707, 0), _V(0,0, 1));
	if (dock1 == NULL) dock1 = CreateDock (_V(-0.75, 0.75 , 7.15), _V(-0.707, 0.707, 0), _V(0.707,0.707, 0));
	SetPMI (_V(210,280,200));  //_V(210,246,175) w/o tanks
	SetCrossSections (_V(286,350,110));  //_V(286,304,77) w/o tanks
	SetCW (0.8, 1.0, 1.4, 1.4);
	SetRotDrag (_V(0.7,0.7,1.2));
	SetPitchMomentScale (1e-6);
	SetBankMomentScale (1e-6);
//	SetLiftCoeffFunc (0); 
//	SetTrimScale (0.05);
	SetCameraOffset(_V(3.44,0.4,14.8));
//	SetMeshVisibilityMode(3,MESHVIS_ALWAYS);

	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* Draw() should be called to render all the loaded payloads, plus anything you've
	/* added with the COMMON_MESH class (not used here) */

	/* call draw to render the payloads, plus anything you've added from COMMON_MESH */
	PlaceComponents();
	Draw();


	/* CVE-lite variable ! */
	/* IMPORTANT */
	/* Use the keyword double InitFuelLevel multipled by the maximum mass to have the
	/* fuel levels automatically set from the GPDS payload string */


//	if (ph_TLI != NULL)
//		DelPropellantResource (ph_TLI);

	/* verify that the propellent hasn't been created before making it */
	if (ph_LAND==NULL)  
		ph_LAND  = CreatePropellantResource(SECOND_PROP_MASS,SECOND_PROP_MASS*InitFuelLevel,1.0); 


	if (ph_TLI!=NULL)
		DelPropellantResource(ph_TLI);
	if (ph_TEI!=NULL)
		DelPropellantResource(ph_TEI);
/*	if (ph_TEI==NULL)  
		ph_TEI  = CreatePropellantResource(THIRD_PROP_MASS,THIRD_PROP_MASS,1.0); 
	if (ph_DOCK==NULL)  
r		ph_DOCK  = CreatePropellantResource(FOURTH_PROP_MASS,FOURTH_PROP_MASS,1.0); 
*/
	SetDefaultPropellantResource (ph_LAND); 
	MakeThrusters (ph_LAND);
}

void VBMOON::SetStage2( )
{
	/* CVE-lite function ! */
	/* ClearMeshesEx() will get rid of all the normal meshes, plus anything you've defined
	/* with the COMMON_MESH class (not used here) */

	/* erase all meshes and thrusters so we can start afresh */
	ClearMeshesEx();
	ClearThrusterDefinitions();
	ClearPropellantResources();

	SetSize (35);

	/* CVE-lite function ! */
	/* IMPORTANT */
	/* double CalculateMass() will return the all-up mass of the combined payloads and
	/* upper stages. Simply add this to your normal dry mass. */
	
	/* always add payload mass [CalculateMass()] to the vessel's empty mass */
	SetEmptyMass ( VBMOON_DRYMASS + CalculateMass() );

	SetTouchdownPoints (_V(0,-12.0,-31.5), _V(-9,9,-31.5), _V(9,9,-31.5));
	if (dock0 == NULL) dock0 = CreateDock (_V( 2.05,-2.05 , 7.15), _V( 0.707,-0.707, 0), _V(0,0, 1));
	if (dock1 == NULL) dock1 = CreateDock (_V(-0.75, 0.75 , 7.15), _V(-0.707, 0.707, 0), _V(0.707,0.707, 0));
	SetPMI (_V(210,246,175));  //_V(210,246,175) w/o tanks
	SetCrossSections (_V(286,304,77));  //_V(286,304,77) w/o tanks
	SetCW (0.8, 1.0, 1.4, 1.4);
	SetRotDrag (_V(0.7,0.7,1.2));
	SetPitchMomentScale (1e-6);
	SetBankMomentScale (1e-6);
//	SetLiftCoeffFunc (0); 
//	SetTrimScale (0.05);
	SetCameraOffset(_V(3.44,0.4,14.8));
//	SetMeshVisibilityMode(3,MESHVIS_ALWAYS);

	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* Draw() should be called to render all the loaded payloads, plus anything you've
	/* added with the COMMON_MESH class (not used here) */

	/* call draw to render the payloads, plus anything you've added from COMMON_MESH */
	PlaceComponents();
	Draw();


	/* CVE-lite variable ! */
	/* IMPORTANT */
	/* Use the keyword double InitFuelLevel multipled by the maximum mass to have the
	/* fuel levels automatically set from the GPDS payload string */

/*
	if (ph_TLI != NULL)
		DelPropellantResource (ph_TLI);
	if (ph_LAND != NULL)
		DelPropellantResource (ph_LAND);
*/

	/* verify that the propellent hasn't been created before making it */
	if (ph_TEI==NULL) 
		if (!cargo)  
			ph_TEI  = CreatePropellantResource(THIRD_PROP_MASS,THIRD_PROP_MASS*InitFuelLevel,1.0); 
		else if (cargo)
			ph_TEI  = CreatePropellantResource(THIRD_PROP_MASS,0.0,1.0); 

	if (stage > 2)
		DelPropellantResource(ph_TEI);
	if (ph_LAND!=NULL)
		DelPropellantResource(ph_LAND);
	if (ph_TLI!=NULL)
		DelPropellantResource(ph_TLI);
//	if (ph_DOCK==NULL)  
//		ph_DOCK  = CreatePropellantResource(FOURTH_PROP_MASS,FOURTH_PROP_MASS,1.0); 

	if (stage < 3) {
		SetDefaultPropellantResource (ph_TEI); 
		MakeThrusters (ph_TEI);
	}
}


/** Handle buffered key events sent to the vessel by orbiter. 
 *  @param dwKey The scan code of the key
 *  @param fPressed true if pressed, false if depressed
 *  @param keystate the current state of the keyboard
 *
 *  modified switch routine by dave rowbotham.
 */

void VBMOON::JettisonPart()
 {
				char name[256];
				if (stage == 0) {
					VESSELSTATUS vs;
					VECTOR3 ofs = _V(0,0,0);
					VECTOR3 vel = _V( 0.5,0,0);
					GetStatus (vs);
					vs.eng_main = vs.eng_hovr = 0.0;
					SetEngineLevel(ENGINE_MAIN, 0);
					VECTOR3 rofs, rvel = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
					Local2Rel (ofs, vs.rpos);
					GlobalRot (vel, rofs);
					vs.rvel.x = rvel.x+rofs.x;
					vs.rvel.y = rvel.y+rofs.y;
					vs.rvel.z = rvel.z+rofs.z;
					vs.vrot.x = 0.0;
					vs.vrot.y = 0.0;
					vs.vrot.z = 0.0;


					strcpy (name, GetName()); strcat (name, "-Tank 1");
					VESSEL::Create (name, "vbproptank1", vs);

					ofs = _V(0,0,0);
					vel = _V(-0.5,0,0);
					GetStatus (vs);
					rofs = _V(vs.rvel.x, vs.rvel.y, vs.rvel.z);
					Local2Rel (ofs, vs.rpos);
					GlobalRot (vel, rofs);
					vs.rvel.x = rvel.x+rofs.x;
					vs.rvel.y = rvel.y+rofs.y;
					vs.rvel.z = rvel.z+rofs.z;
					vs.vrot.x = 0.0;
					vs.vrot.y = 0.0;
					vs.vrot.z = 0.0;


					strcpy (name, GetName()); strcat (name, "-Tank 2");
					VESSEL::Create (name, "vbproptank2", vs);
					stage++;		
					SetMainStage();
//					DelPropellantResource (ph_TEI); 
//					PlayVesselWave3(MyID,PLAYBANG);
				}
				else if (stage == 1) {

					VESSELSTATUS vs;
					VECTOR3 ofs = _V(0,3.5,0);
					VECTOR3 vel = _V(0, 0.5,0);
					GetStatus (vs);
					vs.status = 0;
					vs.eng_main = vs.eng_hovr = 0.0;
					SetEngineLevel(ENGINE_MAIN, 0);
//					vs.eng_hovr = 1.0;
					VECTOR3 rofs, rvel = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
					Local2Rel (ofs, vs.rpos);
					GlobalRot (vel, rofs);
					vs.rvel.x = rvel.x+rofs.x;
					vs.rvel.y = rvel.y+rofs.y;
					vs.rvel.z = rvel.z+rofs.z;
					vs.vrot.x = 0.0;
					vs.vrot.y = 0.0;
					vs.vrot.z = 0.0;


					strcpy (name, GetName()); strcat (name, "-Tank 3");
					VESSEL::Create (name, "vbsidetank1", vs);

					ofs = _V(0,-3.5,0);
					vel = _V(0,-0.5,0);
					GetStatus (vs);
					vs.status = 0;
					vs.eng_main = vs.eng_hovr = 0.0;
					SetEngineLevel(ENGINE_MAIN, 0);
//					vs.eng_hovr = 1.0;
					rofs = _V(vs.rvel.x, vs.rvel.y, vs.rvel.z);
					Local2Rel (ofs, vs.rpos);
					GlobalRot (vel, rofs);
					vs.rvel.x = rvel.x+rofs.x;
					vs.rvel.y = rvel.y+rofs.y;
					vs.rvel.z = rvel.z+rofs.z;
					vs.vrot.x = 0.0;
					vs.vrot.y = 0.0;
					vs.vrot.z = 0.0;


					strcpy (name, GetName()); strcat (name, "-Tank 4");
					VESSEL::Create (name, "vbsidetank2", vs);
					
					if (!mars) {
						if (GetAltitude() > 38.0)
							JettisonLegs();
						else JettLegsArm = true;
					}
					stage++;					
					SetMainStage();
//					DelPropellantResource (ph_deorbit); 
//					PlayVesselWave3(MyID,PLAYBANG);
				}
				else if (stage == 2) {
					if ((mars) || (!cargo)) {
						DeployPayload(_V(0,0,0));
						SetMainStage();
					}
					else {

						VESSELSTATUS vs;
						VECTOR3 ofs = _V(0,0,0);
						VECTOR3 vel = _V(0, 1.0,0);
						GetStatus (vs);
						vs.eng_main = vs.eng_hovr = 0.0;
						SetEngineLevel(ENGINE_MAIN, 0);
//						vs.eng_hovr = 1.0;
						VECTOR3 rofs, rvel = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
						Local2Rel (ofs, vs.rpos);
						GlobalRot (vel, rofs);
						vs.rvel.x = rvel.x+rofs.x;
						vs.rvel.y = rvel.y+rofs.y;
						vs.rvel.z = rvel.z+rofs.z;
						vs.vrot.x = 0.0;
						vs.vrot.y = 0.0;
						vs.vrot.z = 0.0;

						strcpy (name, GetName()); strcat (name, "-Rover 1");
						VESSEL::Create (name, "vbrover", vs);
						vs.status = 0;
						strcpy (name, GetName()); strcat (name, "-Cargo Hab 1");
						VESSEL::Create (name, "vbcgohab1", vs);


						ofs = _V(0,0,0);
						vel = _V(0,-1.0,0);
						GetStatus (vs);
						vs.eng_main = vs.eng_hovr = 0.0;
						SetEngineLevel(ENGINE_MAIN, 0);
//						vs.eng_hovr = 1.0;
						rofs = _V(vs.rvel.x, vs.rvel.y, vs.rvel.z);
						Local2Rel (ofs, vs.rpos);
						GlobalRot (vel, rofs);
						vs.rvel.x = rvel.x+rofs.x;
						vs.rvel.y = rvel.y+rofs.y;
						vs.rvel.z = rvel.z+rofs.z;
						vs.vrot.x = 0.0;
						vs.vrot.y = 0.0;
						vs.vrot.z = 0.0;


						strcpy (name, GetName()); strcat (name, "-Rover 2");
						VESSEL::Create (name, "vbrover", vs);
						vs.status = 0;
						strcpy (name, GetName()); strcat (name, "-Cargo Hab 2");
						VESSEL::Create (name, "vbcgohab2", vs);
						stage++;					
						SetMainStage();
					}
				}
				else {
						DeployPayload(_V(0,0,0));
						SetMainStage();
					}


 }

int VBMOON::ConsumeBufferedKey(DWORD dwKey, bool fPressed, const char *keystate)
{
	if (!fPressed) return 0; // only process keydown events
	if (KEYMOD_SHIFT (keystate)) 
	{
	}
	else if (KEYMOD_CONTROL (keystate)) 
	{
		// insert ctrl key combinations here
	}
	else {

		if (KEYDOWN (keystate, OAPI_KEY_J)) 
		{ // "Jettison Stage"
			if (oapiAcceptDelayedKey (OAPI_KEY_J, 1.0))
			{
				JettisonPart();
			}
			return 1;
		}
		if (KEYDOWN (keystate, OAPI_KEY_G)) 
		{ // "Jettison Stage"
			if (oapiAcceptDelayedKey (OAPI_KEY_G, 1.0))
			{
				RevertLandingGear();
				StopVesselWave3(MyID,PLAYGEAR);
				PlayVesselWave3(MyID,PLAYGEAR);
			}
			return 1;
		}
		if (KEYDOWN (keystate, OAPI_KEY_V)) 
		{ // "Jettison Stage"
			if (oapiAcceptDelayedKey (OAPI_KEY_V, 1.0))
			{
				VECTOR3 defdir;
				GetCameraDefaultDirection(defdir);
				if (defdir.z == 1)
					SetCameraDefaultDirection(_V(0,-1,0));
				else SetCameraDefaultDirection(_V(0,0,1));			}
			return 1;
		}
		if (KEYDOWN (keystate, OAPI_KEY_E)) 
		{ 
			if (oapiAcceptDelayedKey (OAPI_KEY_E, 1.0))
			{
					VESSELSTATUS vs;
					OBJHANDLE hvessel;
					GetStatus (vs);
					vs.eng_main = vs.eng_hovr = 0.0;
					vs.fuel=1.0;
//					vs.status=0;
					VECTOR3 ofs = ASTRO_OFS;
					if (vs.status == 1) ofs = ASTROLANDED_OFS;
					Local2Rel (ofs, vs.rpos);
					char name[256], name2[256];

					UINT i;
					for (i=1;i<52;i++) {
							strcpy (name2, GetName()); 
							sprintf(name, "-%d", i);
							strcat (name2, name);
							hvessel=oapiGetVesselByName(name2);
							if (hvessel == 0) break;
					}
	
					VECTOR3 vel = _V(0,0.0,0.0);
					VECTOR3 rofs, rvel = {vs.rvel.x, vs.rvel.y, vs.rvel.z};
					Local2Rel (ofs, vs.rpos);
					GlobalRot (vel, rofs);
					vs.rvel.x = rvel.x+rofs.x;
					vs.rvel.y = rvel.y+rofs.y;
					vs.rvel.z = rvel.z+rofs.z;
					
					if ((( i < 51) && (!cargo)) || (( i < 21) && (cargo))) {
						VESSEL::Create (name2, "vbsuit", vs);
						hvessel=oapiGetVesselByName(name2);
						oapiSetFocusObject(hvessel);
					}
			}
		return 1;
		}
	}
	return 0;
}



int VBMOON::ConsumeKey( const char *keystate )
{

	return 0;
}


