/**
*
* $Id: vbrover.h,v 0.1 2004/11/20 18:03:45 erv Exp $
* (c) 2004 Sputnik -- erik_h_anderson@hotmail.com
* Based on CVEL Centaur-G code
* Ervins Reinverts -- ervins@gmail.com
* Based on CVEL Fregat code
* (c) 2004 David Henderson -- orbiter@aibs.org.uk
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/


#include "../../include/cvel.h"
#include "../../include/cvelmessage.h"
#include "../../include/orbitersdk.h"
#include "../../include/OrbiterSoundSDK3.h"
#include <cstdio>
#include <cmath>
#include <string>


#define InitFuelLevel 1

#define PLAYTREADS						 27     // the tank noise sound


//const double ISP_FIRST_SL		=     444.0*G; 
//const double ISP_FIRST_VAC		=     444.0*G; //***
//const double THRUST_FIRST_VAC	=    7000.0*G/6.0; //***
//const double MAX_ATT_FIRST		=     250.0*G;
//const double FIRST_PROP_MASS	=   12000.0; //*** 
//const double VBROVER_MAX_BURN	=     625.0; //***
const double VBROVER_DRYMASS	=    6250.0; //***

const VECTOR3 EVA_OFS			= _V(0,1.0,-2.5);

const double HATCH_OPERATING_SPEED = 0.125;


/* make your own vessel class (named VBROVER here, for example)
   subclassed from COMMON_VESSEL_EX */

class VBROVER : public COMMON_VESSEL_EX {
//class VBROVER : public VESSEL2 {
public:
	VBROVER (OBJHANDLE hObj, int fmodel);
	~VBROVER();

	enum DoorStatus { DOOR_CLOSED, DOOR_OPEN, DOOR_CLOSING, DOOR_OPENING } hatch_status;

	void TimeStep(  double simt ); // need a timestep loop to conduct the GPDS polling
	void MoveEVA();
	void VisualCreated( VESSEL *vessel, VISHANDLE vis, int refcount ); // must use VisualCreated() instead of ovcVisualCreated()
	void SetClassCaps(  FILEHANDLE cfg );
	void LoadState(  FILEHANDLE scn, void *vs );
	void SaveState(  FILEHANDLE scn );
	void SeparateEVA();
//	void ActivateHatch (DoorStatus action);
//	void RevertHatch();
//	void UpdateAnimations();
//	void RedrawPanel_MFDButton (SURFHANDLE surf, int mfd, int side);


	/* CVE-lite requirement ! */
	// Create a function that can be called as many times as you like. It is
	// vital to have a function like this that cleans out all the
	// thrusters and meshes and draws/recreates them again.
	// This is so that you can respond immediately to GPDS requests.
	// Here I've called it SetMainStage() it can be Refresh() or anything you like.
	void SetMainStage(); 

//	void SetAttControlsMoonbus();    // this is to set up the thrusters. I like to keep them separate.
	int  ConsumeKey(char *keystate );
	int  ConsumeBufferedKey(DWORD dwKey, bool fPressed, const char *keystate);

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeDirectKey (char *keystate );
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);
//	bool clbkLoadVC (int id);
//	bool clbkVCMouseEvent (int id, int event, VECTOR3 &p);
//	bool clbkVCRedrawEvent (int id, int event, SURFHANDLE surf);

protected:
	PROPELLANT_HANDLE ph_first;
	THRUSTER_HANDLE   th_first[6];
	THGROUP_HANDLE    thg_first,thg_pitchup, thg_pitchdown;
	MESHHANDLE		  hVBRover;
	SURFHANDLE		  tex;
	bool KEY1, KEY2, KEY3, KEY4, KEY5, KEY6, KEY7, KEY8, KEY9;
	double simdt, lastt, simt;

	UINT anim_hatch;	// handle for aft hatch animation
	double hatch_proc;
	int MyID;

	int erasecount;
	OBJHANDLE hvessel, hV;

};

typedef struct {
	HINSTANCE hDLL;
	HFONT font[2];
	DWORD col[4];
	HBRUSH brush[4];
	HPEN pen[2];
} GDIParams;





/* basic vessel class setup */

//

void VBROVER::clbkSetClassCaps (FILEHANDLE cfg)
{
	SetClassCaps(cfg);
}

void VBROVER::clbkLoadStateEx (FILEHANDLE scn, void *vs)
{
	LoadState(  scn, vs );
}

void VBROVER::clbkSaveState (FILEHANDLE scn)
{
	SaveState(  scn );
}

void VBROVER::clbkPostStep (double simt, double simdt, double mjd)
{
	TimeStep(simt);
}

void VBROVER::clbkVisualCreated (VISHANDLE _vis, int refcount)
{
	SetMainStage( );
}

void VBROVER::clbkVisualDestroyed (VISHANDLE _vis, int refcount)
{
	SetMainStage( );
}

int VBROVER::clbkConsumeDirectKey(char *keystate )
{
	ConsumeKey( keystate );
	return 0;
}

int VBROVER::clbkConsumeBufferedKey (DWORD dwKey, bool fPressed, char *keystate)
{
	int ret = ConsumeBufferedKey( dwKey, fPressed, keystate );
	return ret;
}

// --------------------------------------------------------------
// Vessel initialisation
// --------------------------------------------------------------
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new VBROVER (hvessel, flightmodel);
}

// --------------------------------------------------------------
// Vessel cleanup
// --------------------------------------------------------------
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (VBROVER*)vessel;
}



//
