#ifndef _VBWHEEL_H_
#define _VBWHEEL_H_

//#include <common_addon_ex.h>
#include "../../include/cvel.h"
#include <cstdio>

class VBWHEEL: public COMMON_VESSEL_EX {
public:
	VBWHEEL (OBJHANDLE hObj, int fmodel );

	void LoadState (FILEHANDLE scn, void *vs);
	void SaveState (FILEHANDLE scn);
	void SetClassCaps (FILEHANDLE cfg);
	void TimeStep( double simt );
	int  ConsumeBufferedKey ( DWORD dwKey, bool fPressed, const char *keystate);
	int  ConsumeKey ( const char *keystate);
	double SPIN_SPEED;
	double spin_proc;

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);

protected :
	PROPELLANT_HANDLE ph_main, ph_H2O;
	THRUSTER_HANDLE th_main[3];
	THRUSTER_HANDLE th_hover[4];

	THGROUP_HANDLE thg_main;
	THGROUP_HANDLE thg_hover;
	MESHHANDLE  hHawk;
	SURFHANDLE  tex;
	DOCKHANDLE dock0, dock1, dock2, dock3;
	char payloadmesh[256];
	UINT anim_spin;
};


#endif
